
/* ReachingDefsStandard.hpp
   NOTE: This file was automatically generated by DFAGen.  It is the interface
         for the ReachingDefs analysis results.
*/

#ifndef ReachingDefsStandard_hpp
#define ReachingDefsStandard_hpp

#include <cassert>
#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <OpenAnalysis/Utils/OA_ptr.hpp>
#include <OpenAnalysis/IRInterface/IRHandles.hpp>
#include <OpenAnalysis/IRInterface/auto_ReachingDefsIRInterface.hpp>
#include <OpenAnalysis/OABase/Annotation.hpp>
#include <OpenAnalysis/Utils/GenOutputTool.hpp>
#include <OpenAnalysis/Location/Location.hpp>
#include <OpenAnalysis/DataFlow/DFAGenDFSet.hpp>
#include <OpenAnalysis/Utils/Util.hpp>

namespace OA {
  namespace ReachingDefs {

typedef DataFlow::DFAGenDFSet<StmtHandle > ReachingDefsDFSet;

class ReachingDefsStandard : public virtual Annotation {
  public:
    ReachingDefsStandard(ProcHandle p, OA_ptr<ReachingDefsIRInterface> _ir) {
        mIR = _ir;
        mExitReachingDefs = new ReachingDefsDFSet();
    }
    ~ReachingDefsStandard() {}

    ReachingDefsDFSet::iterator getReachingDefsIterator(StmtHandle s);

    ReachingDefsDFSet::iterator getExitReachingDefsIterator();

    void insert(StmtHandle s, StmtHandle  val) {
        if(mReachingDefs[s].ptrEqual(0)) {
            mReachingDefs[s] = new ReachingDefsDFSet();
        }
        mReachingDefs[s]->insert(val);
    }

    void insertExit(StmtHandle  val) {
        mExitReachingDefs->insert(val);
    }

    OA_ptr<ReachingDefsDFSet> getReachingDefsSet(StmtHandle s) {
        map<StmtHandle, OA_ptr<ReachingDefsDFSet> >::iterator element =
            mReachingDefs.find(s);

        if(element == mReachingDefs.end()) {
            mReachingDefs[s] = new ReachingDefsDFSet();
            element = mReachingDefs.find(s);
        }

        return (*element).second;
    }

    void output(IRHandlesIRInterface& pIR);

    void dump(std::ostream& os, OA_ptr<IRHandlesIRInterface> ir);

  private:
    map<StmtHandle, OA_ptr<ReachingDefsDFSet> > mReachingDefs;
    OA_ptr<ReachingDefsDFSet>  mExitReachingDefs;
    OA_ptr<ReachingDefsIRInterface> mIR;
};

  } // end of Liveness namespace
} // end of OA namespace

#endif

